'--------------------------------------------
'Author      :   Dr. Fritz Faulhaber GmbH & Co. KG
'Date        :   04.12.2015
'--------------------------------------------
'Description :   A simple break/enable implementation
'                DI1 is used as an EN Pin
'                DI2 is used to break - change to QS if disabled
'--------------------------------------------

'Init
z = 4
' z = 1: disabled
' z = 2: waiting for enable
' z = 3: enabled
' z = 4: waiting for disable
' z = 5: waiting for QS
' z = 6: QS active

SETOBJ $6060.$00 = 9   'CSV

s = GETOBJ $6041.$00
IF (s & $00FF) = $40 THEN
   'Disabled
   z = 1
ENDIF
IF (s & $00FF) = $27 THEN
   'Enabled
   z = 3
ENDIF
IF (s & $00FF) = $07 THEN
   'Stopped
   z = 6
ENDIF

:MainLoop

s = GETOBJ $6041.$00
a = GETOBJ $2311.$01

IF z = 4 THEN
   IF (s & $00FF) = $40 THEN
      'Disabled
      z = 1
   ENDIF
ENDIF

IF z = 2 THEN
   IF (s & $00FF) = $27 THEN
      'Enabled
      z = 3
   ENDIF
ENDIF

IF z = 5 THEN
   IF (s & $00FF) = $07 THEN
      'Stopped
      z = 6
   ENDIF
ENDIF

IF z = 1 THEN GOSUB Z1
IF z = 3 THEN GOSUB Z3
IF z = 6 THEN GOSUB Z6

GOTO MainLoop

:Z1
'Status Diabled
'switch to enabled, if In1 is set
IF (a & 1) >  0 THEN
   'issue shutdown and enable OpCommand
   SETOBJ $6040.$00 = $0006
   SETOBJ $6040.$00 = $000F
   'switch to next
   z = 2
ENDIF
RETURN

:Z3
'This is the enbaled state
'switch to QS in case of In2 missing
'switch to DI in case of In1 missing
SETOBJ $60FF.$00 = 10
IF a = 2 THEN
   'In1 missing  --> Disable
   SETOBJ $6040.$00 = $0000
   z = 4
ENDIF
IF a = 1 THEN
   'In2 missing --> issue QS
   SETOBJ $6040.$00 = $0002
   z = 5
ENDIF
RETURN

:Z6
'This is the QS
'switch to EN in case of In2 is back
'switch to DI in case of In1 missing
IF a = 2 THEN
   'In1 missing  --> Disable
   SETOBJ $6040.$00 = $0000
   z = 4
ENDIF
IF a = 3 THEN
   'In2 is back --> enable
   ' SETOBJ $6040.$00 = $0006
   SETOBJ $6040.$00 = $000F
   z = 2
ENDIF
RETURN


