'--------------------------------------------
'Author      : Dr. Fritz Faulhaber GmbH & Co. KG
'Date        : 17.03.2016
'--------------------------------------------
'Description : Program control via interface
'
'Sequence program for controllers of the family MC V3.x,
'that can be controlled via the interface by means of 
'the communication variables x and y.
'As remote station the script CmdProgSeq.vbs can be used.
'--------------------------------------------
DEF_TIM_VAR t                                                            'Definition of timer variable
DEF_EVT_VAR e                                                            'Definition of event mask variable
EN_EVT $0000FFFF, EvtHandler                                             'Activate event handling for selected events

'Initialize communication variables x and y
x = 0
y = 0

GOSUB Initialize
GOSUB SetTimer_500

z = 1                                                                    'Step counter
:MainLoop
IF z = 1 THEN GOSUB CheckTimer
IF z = 2 THEN GOSUB CheckCommand
GOTO MainLoop

'Set Profile Position Mode and activate power stage
:Initialize
SETOBJ $6060.00 = 3                                                      'Modes of operation
a = GETOBJ $6041.00                                                      'Request Statusword
IF (a & $004) <> $004 THEN                                               '"Operation Enabled" not set
    SETOBJ $6040.00 = $06                                                'Shutdown
    SETOBJ $6040.00 = $07                                                'Switch On
    SETOBJ $6040.00 = $0F                                                'Enable Operation
ENDIF
z = z + 1
RETURN

'Set 500ms waiting time
:SetTimer_500
START_TIM 500
z = z + 1
RETURN

'Wait until time expired
:CheckTimer
IF t = 1 THEN
    z = z + 1
ENDIF
RETURN

:CheckCommand
IF x = 1 THEN
    x = 0
    'Profile 1:
    SETOBJ $6083.00 = 100
    SETOBJ $60FF.00 = 100
ENDIF
IF x = 2 THEN
    x = 0
    'Profile 2:
    SETOBJ $6083.00 = 1000
    SETOBJ $60FF.00 = 500
ENDIF
IF x = 3 THEN
    x = 0
    'Profile 3:
    SETOBJ $6083.00 = 100
    SETOBJ $60E0.00 = 100
    SETOBJ $60FF.00 = 100
ENDIF
IF x = 9 THEN
    x = 0
    'Stop motor:
    SETOBJ $6084.00 = 100
    SETOBJ $60E0.00 = 2000
    SETOBJ $60FF.00 = 0
ENDIF
RETURN

:EvtHandler
IF e & $00000001 THEN
    y = 1                                                                'Velocity 0 reached
ENDIF
IF e & $00004000 THEN
    y = 2                                                                'Torque limited
ENDIF
RET_EVT
